#include "common.hh"
#include "bleaf.hh"

#define ADDPOINT(P) \
  if (P.location().x() < inf.x()) inf.x (P.location().x()); \
  if (P.location().y() < inf.y()) inf.y (P.location().y()); \
  if (P.location().z() < inf.z()) inf.z (P.location().z()); \
  if (P.location().x() > sup.x()) sup.x (P.location().x()); \
  if (P.location().y() > sup.y()) sup.y (P.location().y()); \
  if (P.location().z() > sup.z()) sup.z (P.location().z()); \
  if (P.newl().x() < inf.x()) inf.x (P.newl().x()); \
  if (P.newl().y() < inf.y()) inf.y (P.newl().y()); \
  if (P.newl().z() < inf.z()) inf.z (P.newl().z()); \
  if (P.newl().x() > sup.x()) sup.x (P.newl().x()); \
  if (P.newl().y() > sup.y()) sup.y (P.newl().y()); \
  if (P.newl().z() > sup.z()) sup.z (P.newl().z());
void BLeaf::computeBounds() {
  inf = a.location();
  sup = a.location();
  if (a.newl().x() < inf.x()) inf.x (a.newl().x());
  if (a.newl().y() < inf.y()) inf.y (a.newl().y());
  if (a.newl().z() < inf.z()) inf.z (a.newl().z());
  if (a.newl().x() > sup.x()) sup.x (a.newl().x());
  if (a.newl().y() > sup.y()) sup.y (a.newl().y());
  if (a.newl().z() > sup.z()) sup.z (a.newl().z());
  ADDPOINT(b);
  ADDPOINT(c);
  ADDPOINT(d);
}

void BLeaf::intersect (Vertex& p, const Vector& pInf, const Vector& pSup) {
  if ((&p == &b) || (&p == &c)) return;
  if (&p != &a) p.intersect (a, b, c);
  if (&p != &d) p.intersect (d, c, b);
}
