#include "common.hh"
#include "bnode.hh"

using namespace std;

void BNode::computeBounds() {
  list<BBox*>::iterator child = children.begin();
  (*child)->computeBounds();
  inf = (*child)->inf;
  sup = (*child)->sup;
  child++;
  for (; child != children.end(); child++) {
    (*child)->computeBounds();
    if ((*child)->inf.x() < inf.x()) inf.x ((*child)->inf.x());
    if ((*child)->inf.y() < inf.y()) inf.y ((*child)->inf.y());
    if ((*child)->inf.z() < inf.z()) inf.z ((*child)->inf.z());
    if ((*child)->sup.x() > sup.x()) sup.x ((*child)->sup.x());
    if ((*child)->sup.y() > sup.y()) sup.y ((*child)->sup.y());
    if ((*child)->sup.z() > sup.z()) sup.z ((*child)->sup.z());
  }
}

BNode::~BNode() {
  for (list<BBox*>::iterator child = children.begin();
       child != children.end(); child++)
    delete *child;
}

void BNode::intersect (Vertex& p, const Vector& pInf, const Vector& pSup) {
  for (list<BBox*>::iterator child = children.begin();
       child != children.end(); child++)
    if ((pInf.x() <= (*child)->sup.x()) && ((*child)->inf.x() <= pSup.x()) &&
        (pInf.y() <= (*child)->sup.y()) && ((*child)->inf.y() <= pSup.y()) &&
        (pInf.z() <= (*child)->sup.z()) && ((*child)->inf.z() <= pSup.z()))
      (*child)->intersect (p, pInf, pSup);
}
