#ifndef BNODE_HH
#define BNODE_HH

#include "bbox.hh"
#include <list>

class BNode: public BBox {
private:
  std::list<BBox*> children;

public:
  BNode() {};
  virtual void computeBounds();
  void addChild (BBox* b) { children.push_front (b); }
  virtual ~BNode();

protected:
  virtual void intersect (Vertex& p, const Vector& pInf, const Vector& pSup);
};

#else

class BNode;

#endif
