#include "common.hh"
#include "ground.hh"
#include "utils.hh"

GroundPlane::GroundPlane (double pos, double ifriction): Object (ifriction), dist_(pos) {}

const bool GroundPlane::inside (Vector& point, const Vector& old) const {
  if (point.z() < dist_) {
    if (old.z() >= dist_+EPSILON) {
      double lambda = 0.99*(dist_-old.z())/(point.z()-old.z());
      point = old + lambda*(point-old);
    } else point = old;
    //if (isInside (point)) segFault();
    return true;
  }
  return false;
}

const void GroundPlane::adjust (Vector& force, const Vector& point) const {
  if (point.z() <= dist_+EPSILON)
    computeFriction (force, Z);
}

const bool GroundPlane::isInside (const Vector& point) const {
  return (point.z() < dist_);
}
