#ifndef HF_HH
#define HF_HH

#include "object.hh"
#include "vector.hh"

class HeightField: public Object {
private:
  double* data;
  Vector origin;
  Vector size;
  int length, width;
public:
  HeightField (char* file);
  virtual const bool inside (Vector& point, const Vector& old) const;
  virtual const void adjust (Vector& force, const Vector& point) const;
  virtual const bool isInside (const Vector& point) const;
  virtual ~HeightField() { delete[] data; data = (double*)-1; }

  void translate (const Vector&);
  void scale (const Vector&);
};

#else

class HeightField;

#endif
