#ifndef OBJECT_HH
#define OBJECT_HH

#include "common.hh"
#include "vector.hh"

class Object {
protected:
  double friction;
public:
  Object (double ifriction = FRICTION): friction (ifriction) {}
  virtual const bool inside (Vector& point, const Vector& old) const=0;
  virtual const void adjust (Vector& force, const Vector& point) const=0;
  virtual const bool isInside (const Vector& point) const=0;
  virtual ~Object() {}

protected:
  const void computeFriction (Vector& force, const Vector& normal) const;
};

#else

class Object;

#endif
