/* A Bison parser, made from parser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	NUMBER	257
# define	STRING	258
# define	COMMA	259
# define	LCURL	260
# define	RCURL	261
# define	LBRACKET	262
# define	RBRACKET	263
# define	LPAREN	264
# define	RPAREN	265
# define	GLOBAL_SETTINGS	266
# define	STEP	267
# define	OUTPUT	268
# define	MESH	269
# define	MESH2	270
# define	CYLINDERS	271
# define	WIND	272
# define	VISCOSITY	273
# define	GRAVITY	274
# define	CLOTH	275
# define	XSIZE	276
# define	YSIZE	277
# define	DIST	278
# define	STRENGTH	279
# define	SHEAR	280
# define	STIFF	281
# define	WEIGHT	282
# define	HNOISE	283
# define	VNOISE	284
# define	ELONGATION	285
# define	DAMPING	286
# define	READ_FILE	287
# define	POSITION	288
# define	INTERSECTIONS	289
# define	TRANSLATE	290
# define	ROTATE	291
# define	SCALE	292
# define	ATTACH	293
# define	GROUND	294
# define	BOX	295
# define	CYLINDER	296
# define	SPHERE	297
# define	HF	298
# define	TGA	299
# define	ON	300
# define	OFF	301
# define	X_VECTOR	302
# define	Y_VECTOR	303
# define	Z_VECTOR	304
# define	PLUS	305
# define	MINUS	306
# define	TIMES	307
# define	OVER	308
# define	NEG	309

#line 1 "parser.y"

#include "box.hh"
#include "common.hh"
#include "cylinder.hh"
#include "ground.hh"
#include "hf.hh"
#include "object.hh"
#include "sphere.hh"
#include "vector.hh"
#include "vertex.hh"

#include <fstream>
#include <string>

using namespace std;

int yylex();
void yyerror(char* msg);

class DefaultClothPosition {
public:
  const Vector orig, dir1, dir2;
  DefaultClothPosition (const Vector& orig_, const Vector& d1, const Vector& d2):
    orig(orig_), dir1(d1), dir2(d2) { }
};

class ClothParams {
public:
  int xSize, ySize;
  double dist, d2, strength, s2, curve, weight, hNoise, vNoise, elongation, damping;
  ifstream* read_file;
  DefaultClothPosition* clothPos;
  bool inters;

  ClothParams(): xSize(100), ySize(100), dist(1),
    d2(1.4142135623730951454746218587388284504413604736328125),
    strength(2), s2(1), curve(0.05), weight(0.25),
    hNoise(0.05), vNoise(0.1), elongation(0.1), damping(0.1), read_file(NULL),
    clothPos(NULL), inters(false) {}
  ~ClothParams() { if (clothPos != NULL) delete clothPos; clothPos = NULL; }
} clothParams;


#line 45 "parser.y"
#ifndef YYSTYPE
typedef union {
  Vector* vec;
  double dbl;
  char* str;
  bool boo;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		180
#define	YYFLAG		-32768
#define	YYNTBASE	56

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 309 ? yytranslate[x] : 75)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     4,     7,    12,    13,    16,    19,    22,    25,
      28,    31,    33,    35,    37,    38,    45,    46,    49,    52,
      55,    58,    61,    64,    67,    70,    73,    76,    79,    82,
      85,    94,    97,    98,   101,   104,   107,   116,   127,   128,
     131,   136,   143,   150,   159,   168,   179,   186,   195,   196,
     204,   205,   208,   211,   214,   222,   224,   226,   228,   232,
     236,   240,   244,   248,   252,   255,   257,   260,   263,   267,
     271,   275,   279,   283,   285,   287
};
static const short yyrhs[] =
{
      57,    61,    67,     0,    61,    67,     0,    12,     6,    58,
       7,     0,     0,    58,    59,     0,    13,    73,     0,    14,
      60,     0,    18,    72,     0,    19,    73,     0,    20,    72,
       0,    15,     0,    16,     0,    17,     0,     0,    21,     6,
      63,    62,    65,     7,     0,     0,    63,    64,     0,    22,
      73,     0,    23,    73,     0,    24,    73,     0,    25,    73,
       0,    26,    73,     0,    27,    73,     0,    28,    73,     0,
      29,    73,     0,    30,    73,     0,    31,    73,     0,    32,
      73,     0,    33,     4,     0,    34,     6,    72,     5,    72,
       5,    72,     7,     0,    35,    74,     0,     0,    65,    66,
       0,    36,    72,     0,    37,    72,     0,    39,     6,    73,
       5,    73,     5,    72,     7,     0,    39,     6,    73,     5,
      73,     5,    72,     5,    72,     7,     0,     0,    67,    68,
       0,    40,     6,    73,     7,     0,    40,     6,    73,     5,
      73,     7,     0,    41,     6,    72,     5,    72,     7,     0,
      41,     6,    72,     5,    72,     5,    73,     7,     0,    42,
       6,    72,     5,    72,     5,    73,     7,     0,    42,     6,
      72,     5,    72,     5,    73,     5,    73,     7,     0,    43,
       6,    72,     5,    73,     7,     0,    43,     6,    72,     5,
      73,     5,    73,     7,     0,     0,    44,     6,    45,     4,
      69,    70,     7,     0,     0,    70,    71,     0,    36,    72,
       0,    38,    72,     0,     8,    73,     5,    73,     5,    73,
       9,     0,    48,     0,    49,     0,    50,     0,    72,    51,
      72,     0,    72,    52,    72,     0,    73,    53,    72,     0,
      72,    53,    73,     0,    72,    54,    73,     0,    10,    72,
      11,     0,    52,    72,     0,     3,     0,    51,    73,     0,
      52,    73,     0,    73,    51,    73,     0,    73,    52,    73,
       0,    73,    53,    73,     0,    73,    54,    73,     0,    10,
      73,    11,     0,    46,     0,    47,     0,    73,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    76,    77,    80,    83,    84,    87,    88,    89,    90,
      91,    94,    95,    96,    99,    99,   146,   147,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   167,   170,   171,   174,   175,   176,   178,   182,   183,
     186,   188,   190,   192,   194,   196,   198,   200,   202,   202,
     205,   206,   209,   211,   215,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   229,   230,   231,   232,   233,
     234,   235,   236,   239,   240,   241
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "NUMBER", "STRING", "COMMA", "LCURL", 
  "RCURL", "LBRACKET", "RBRACKET", "LPAREN", "RPAREN", "GLOBAL_SETTINGS", 
  "STEP", "OUTPUT", "MESH", "MESH2", "CYLINDERS", "WIND", "VISCOSITY", 
  "GRAVITY", "CLOTH", "XSIZE", "YSIZE", "DIST", "STRENGTH", "SHEAR", 
  "STIFF", "WEIGHT", "HNOISE", "VNOISE", "ELONGATION", "DAMPING", 
  "READ_FILE", "POSITION", "INTERSECTIONS", "TRANSLATE", "ROTATE", 
  "SCALE", "ATTACH", "GROUND", "BOX", "CYLINDER", "SPHERE", "HF", "TGA", 
  "ON", "OFF", "X_VECTOR", "Y_VECTOR", "Z_VECTOR", "PLUS", "MINUS", 
  "TIMES", "OVER", "NEG", "input", "global_settings", "settings", 
  "setting", "output_type", "cloth", "@1", "cloth_params", "cloth_param", 
  "transforms", "transform", "objects", "object", "@2", "hf_transforms", 
  "hf_transform", "vector", "num", "boolean", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    56,    56,    57,    58,    58,    59,    59,    59,    59,
      59,    60,    60,    60,    62,    61,    63,    63,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    65,    65,    66,    66,    66,    66,    67,    67,
      68,    68,    68,    68,    68,    68,    68,    68,    69,    68,
      70,    70,    71,    71,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    73,    73,    73,    73,    73,
      73,    73,    73,    74,    74,    74
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     3,     2,     4,     0,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     0,     6,     0,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       8,     2,     0,     2,     2,     2,     8,    10,     0,     2,
       4,     6,     6,     8,     8,    10,     6,     8,     0,     7,
       0,     2,     2,     2,     7,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     2,     1,     2,     2,     3,     3,
       3,     3,     3,     1,     1,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     0,     0,     0,    38,     4,    16,    38,     2,     0,
      14,     1,     0,     0,     0,     0,     0,    39,     3,     0,
       0,     0,     0,     0,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    32,
      17,     0,     0,     0,     0,     0,    65,     0,     0,     0,
       6,    11,    12,    13,     7,     0,     0,    55,    56,    57,
       0,     8,     0,     9,    10,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,     0,    73,    74,
      75,    31,     0,     0,     0,     0,     0,     0,     0,    66,
      67,     0,     0,     0,     0,     0,     0,     0,    64,    67,
       0,     0,     0,     0,     0,     0,    15,     0,     0,     0,
      33,     0,    40,     0,     0,     0,    48,    72,    68,    69,
      70,    71,     0,    63,    58,    59,    61,    62,    60,    70,
       0,    34,    35,     0,     0,     0,     0,     0,    50,     0,
       0,     0,    41,     0,    42,     0,     0,    46,     0,     0,
       0,     0,     0,     0,     0,    49,     0,     0,    51,     0,
       0,     0,    43,     0,    44,    47,    52,    53,    54,    30,
       0,     0,     0,    45,     0,    36,     0,    37,     0,     0,
       0
};

static const short yydefgoto[] =
{
     178,     3,     9,    24,    54,     4,    39,    10,    40,    82,
     110,     8,    17,   138,   148,   158,    61,    62,    81
};

static const short yypact[] =
{
      15,    19,    25,    -3,-32768,-32768,-32768,-32768,   232,   321,
     292,   232,    29,    45,    73,    74,    76,-32768,-32768,     4,
      -5,    -2,     4,    -2,-32768,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,    72,    77,     6,-32768,
  -32768,     4,    -2,    -2,    -2,   -22,-32768,     4,     4,     4,
     -13,-32768,-32768,-32768,-32768,     4,    -2,-32768,-32768,-32768,
      -2,    84,    92,   -13,    84,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,   -13,   -13,   -13,-32768,    -2,-32768,-32768,
     -13,-32768,   264,     8,    12,    62,    88,    82,    -9,-32768,
  -32768,     4,     4,     4,     4,   101,   239,   259,-32768,-32768,
      -2,    -2,     4,     4,    -2,   124,-32768,    -2,    -2,    81,
  -32768,     4,-32768,    -2,    -2,     4,-32768,-32768,   -49,   -49,
  -32768,-32768,     4,-32768,   -24,   -24,-32768,-32768,-32768,-32768,
      -2,    84,    84,     4,   191,    17,   143,    21,-32768,   155,
     174,   178,-32768,     4,-32768,     4,     4,-32768,    -4,     4,
      -2,     4,   195,   105,   203,-32768,    -2,    -2,-32768,   229,
     207,   183,-32768,     4,-32768,-32768,    84,    84,-32768,-32768,
      -2,   211,   115,-32768,    -2,-32768,   215,-32768,    94,   109,
  -32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,-32768,-32768,    85,-32768,-32768,-32768,-32768,
  -32768,   114,-32768,-32768,-32768,-32768,   -23,    70,-32768
};


#define	YYLAST		341


static const short yytable[] =
{
      64,    46,   117,   155,    93,    94,    55,    46,    56,    46,
      51,    52,    53,   111,    47,   112,    47,   113,     2,    84,
      85,    86,   143,    87,   144,     5,   146,     1,   147,   102,
     103,     6,   156,    96,   157,    41,     2,    98,    91,    92,
      93,    94,    91,    92,    93,    94,    57,    58,    59,    48,
      60,    42,    78,    79,   105,    48,    49,    48,    49,    91,
      92,    93,    94,   100,   101,   102,   103,   114,   100,   101,
     102,   103,    91,    92,    93,    94,    76,   124,   125,    43,
      44,   128,    45,    77,   131,   132,   116,   133,     7,    50,
     135,   136,    63,   115,   179,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,   122,   140,    80,   180,
     163,    83,   164,   100,   101,   102,   103,    88,    89,    90,
     174,    11,   175,     0,     0,    95,    97,   160,     0,   130,
      99,     0,     0,   166,   167,   100,   101,   102,   103,   100,
     101,   102,   103,    91,    92,   104,    94,   172,   145,     0,
       0,   176,    91,    92,    93,    94,    91,    92,    93,    94,
     149,   118,   119,   120,   121,     0,   100,   101,   102,   103,
       0,     0,   126,   127,   129,   100,   101,   102,   103,   150,
       0,   134,     0,   151,     0,   137,     0,     0,   170,     0,
       0,     0,   139,     0,   100,   101,   102,   103,   142,     0,
       0,     0,   162,   141,     0,     0,    91,    92,    93,    94,
     165,     0,     0,   152,   169,   153,   154,     0,   173,   159,
       0,   161,   177,     0,     0,   100,   101,   102,   103,    91,
      92,    93,    94,   171,    91,    92,    93,    94,   168,     0,
       0,     0,    91,    92,    93,    94,    91,    92,    93,    94,
     123,     0,     0,     0,    91,    92,    93,    94,   100,   101,
     102,   103,    91,    92,    93,    94,   100,   101,   102,   103,
     117,   106,    12,    13,    14,    15,    16,     0,     0,     0,
      91,    92,    93,    94,     0,     0,     0,     0,     0,     0,
     100,   101,   102,   103,     0,     0,     0,     0,     0,     0,
     107,   108,     0,   109,     0,     0,     0,     0,     0,     0,
      91,    92,   104,    94,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    18,     0,
       0,     0,     0,     0,    19,    20,     0,     0,     0,    21,
      22,    23
};

static const short yycheck[] =
{
      23,     3,    11,     7,    53,    54,     8,     3,    10,     3,
      15,    16,    17,     5,    10,     7,    10,     5,    21,    42,
      43,    44,     5,    45,     7,     6,     5,    12,     7,    53,
      54,     6,    36,    56,    38,     6,    21,    60,    51,    52,
      53,    54,    51,    52,    53,    54,    48,    49,    50,    51,
      52,     6,    46,    47,    77,    51,    52,    51,    52,    51,
      52,    53,    54,    51,    52,    53,    54,     5,    51,    52,
      53,    54,    51,    52,    53,    54,     4,   100,   101,     6,
       6,   104,     6,     6,   107,   108,     4,     6,     3,    19,
     113,   114,    22,     5,     0,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,     5,   130,    38,     0,
       5,    41,     7,    51,    52,    53,    54,    47,    48,    49,
       5,     7,     7,    -1,    -1,    55,    56,   150,    -1,     5,
      60,    -1,    -1,   156,   157,    51,    52,    53,    54,    51,
      52,    53,    54,    51,    52,    53,    54,   170,     5,    -1,
      -1,   174,    51,    52,    53,    54,    51,    52,    53,    54,
       5,    91,    92,    93,    94,    -1,    51,    52,    53,    54,
      -1,    -1,   102,   103,   104,    51,    52,    53,    54,     5,
      -1,   111,    -1,     5,    -1,   115,    -1,    -1,     5,    -1,
      -1,    -1,   122,    -1,    51,    52,    53,    54,     7,    -1,
      -1,    -1,     7,   133,    -1,    -1,    51,    52,    53,    54,
       7,    -1,    -1,   143,     7,   145,   146,    -1,     7,   149,
      -1,   151,     7,    -1,    -1,    51,    52,    53,    54,    51,
      52,    53,    54,   163,    51,    52,    53,    54,     9,    -1,
      -1,    -1,    51,    52,    53,    54,    51,    52,    53,    54,
      11,    -1,    -1,    -1,    51,    52,    53,    54,    51,    52,
      53,    54,    51,    52,    53,    54,    51,    52,    53,    54,
      11,     7,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    37,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    -1,    -1,    -1,    18,
      19,    20
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 6:
#line 87 "parser.y"
{ step = yyvsp[0].dbl;                ;
    break;}
case 8:
#line 89 "parser.y"
{ wind = *yyvsp[0].vec; delete yyvsp[0].vec;    ;
    break;}
case 9:
#line 90 "parser.y"
{ visc = yyvsp[0].dbl;                ;
    break;}
case 10:
#line 91 "parser.y"
{ gravity = *yyvsp[0].vec; delete yyvsp[0].vec; ;
    break;}
case 11:
#line 94 "parser.y"
{ output_type = mesh;           ;
    break;}
case 12:
#line 95 "parser.y"
{ output_type = mesh2;          ;
    break;}
case 13:
#line 96 "parser.y"
{ output_type = cylinders;      ;
    break;}
case 14:
#line 100 "parser.y"
{
    if (clothParams.read_file == NULL) {
      if (clothParams.clothPos == NULL)
        cloth = new Cloth (clothParams.xSize, clothParams.ySize, clothParams.dist,
                           clothParams.d2*clothParams.dist,
                           clothParams.strength/clothParams.dist,
                           clothParams.s2/clothParams.dist,
                           clothParams.curve/clothParams.dist,
                           clothParams.weight*clothParams.dist*clothParams.dist,
                           clothParams.hNoise, clothParams.vNoise,
                           clothParams.elongation, clothParams.damping/step,
                           clothParams.inters);
      else
        cloth = new Cloth (clothParams.xSize, clothParams.ySize, clothParams.dist,
                           clothParams.d2*clothParams.dist,
                           clothParams.strength/clothParams.dist,
                           clothParams.s2/clothParams.dist,
                           clothParams.curve/clothParams.dist,
                           clothParams.weight*clothParams.dist*clothParams.dist,
                           clothParams.hNoise, clothParams.vNoise, clothParams.elongation,
                           clothParams.damping/step, clothParams.inters,
                           clothParams.clothPos->orig,
                           clothParams.clothPos->dir1, clothParams.clothPos->dir2);
    } else {
      string s;
      char c;
      while ((clothParams.read_file->good()) && ((c = clothParams.read_file->get()) != '\n'))
        s += c;
      if (!clothParams.read_file->good())
        yyerror ("Unexpected end of file in cloth data\n");
      (*clothParams.read_file) >> clothParams.xSize;
      (*clothParams.read_file) >> clothParams.ySize;
      cloth = new Cloth (*clothParams.read_file, s, clothParams.xSize, clothParams.ySize,
                         clothParams.dist, clothParams.d2*clothParams.dist,
                         clothParams.strength/clothParams.dist,
                         clothParams.s2/clothParams.dist,
                         clothParams.curve/clothParams.dist,
                         clothParams.weight*clothParams.dist*clothParams.dist,
                         clothParams.hNoise, clothParams.vNoise, clothParams.elongation,
                         clothParams.damping/step, clothParams.inters);
      delete clothParams.read_file;
    }
  ;
    break;}
case 18:
#line 150 "parser.y"
{ clothParams.xSize      = static_cast<int> (yyvsp[0].dbl); ;
    break;}
case 19:
#line 151 "parser.y"
{ clothParams.ySize      = static_cast<int> (yyvsp[0].dbl); ;
    break;}
case 20:
#line 152 "parser.y"
{ clothParams.dist       = yyvsp[0].dbl;  ;
    break;}
case 21:
#line 153 "parser.y"
{ clothParams.strength   = yyvsp[0].dbl;  ;
    break;}
case 22:
#line 154 "parser.y"
{ clothParams.s2         = yyvsp[0].dbl;  ;
    break;}
case 23:
#line 155 "parser.y"
{ clothParams.curve      = yyvsp[0].dbl;  ;
    break;}
case 24:
#line 156 "parser.y"
{ clothParams.weight     = yyvsp[0].dbl;  ;
    break;}
case 25:
#line 157 "parser.y"
{ clothParams.hNoise     = yyvsp[0].dbl;  ;
    break;}
case 26:
#line 158 "parser.y"
{ clothParams.vNoise     = yyvsp[0].dbl;  ;
    break;}
case 27:
#line 159 "parser.y"
{ clothParams.elongation = yyvsp[0].dbl;  ;
    break;}
case 28:
#line 160 "parser.y"
{ clothParams.damping    = yyvsp[0].dbl;  ;
    break;}
case 29:
#line 161 "parser.y"
{ clothParams.read_file = new ifstream (yyvsp[0].str); delete yyvsp[0].str; ;
    break;}
case 30:
#line 163 "parser.y"
{
                          clothParams.clothPos = new DefaultClothPosition (*yyvsp[-5].vec, *yyvsp[-3].vec, *yyvsp[-1].vec);
                          delete yyvsp[-5].vec; delete yyvsp[-3].vec; delete yyvsp[-1].vec;
                        ;
    break;}
case 31:
#line 167 "parser.y"
{ clothParams.inters = yyvsp[0].boo; ;
    break;}
case 34:
#line 174 "parser.y"
{ cloth->translate (*yyvsp[0].vec); delete yyvsp[0].vec; ;
    break;}
case 35:
#line 175 "parser.y"
{ cloth->rotate (*yyvsp[0].vec); delete yyvsp[0].vec;    ;
    break;}
case 36:
#line 177 "parser.y"
{ cloth->attach (yyvsp[-5].dbl, yyvsp[-3].dbl, *yyvsp[-1].vec); delete yyvsp[-1].vec; ;
    break;}
case 37:
#line 179 "parser.y"
{ cloth->attach (yyvsp[-7].dbl, yyvsp[-5].dbl, *yyvsp[-3].vec, *yyvsp[-1].vec); delete yyvsp[-3].vec; delete yyvsp[-1].vec ;
    break;}
case 40:
#line 187 "parser.y"
{ world.push_front (new GroundPlane (yyvsp[-1].dbl));      ;
    break;}
case 41:
#line 189 "parser.y"
{ world.push_front (new GroundPlane (yyvsp[-3].dbl, yyvsp[-1].dbl));  ;
    break;}
case 42:
#line 191 "parser.y"
{ world.push_front (new Box (*yyvsp[-3].vec, *yyvsp[-1].vec)); delete yyvsp[-3].vec; delete yyvsp[-1].vec; ;
    break;}
case 43:
#line 193 "parser.y"
{ world.push_front (new Box (*yyvsp[-5].vec, *yyvsp[-3].vec, yyvsp[-1].dbl)); delete yyvsp[-5].vec; delete yyvsp[-3].vec; ;
    break;}
case 44:
#line 195 "parser.y"
{ world.push_front (new Cylinder (*yyvsp[-5].vec, *yyvsp[-3].vec, yyvsp[-1].dbl)); delete yyvsp[-5].vec; delete yyvsp[-3].vec; ;
    break;}
case 45:
#line 197 "parser.y"
{ world.push_front (new Cylinder (*yyvsp[-7].vec, *yyvsp[-5].vec, yyvsp[-3].dbl, yyvsp[-1].dbl)); delete yyvsp[-7].vec; delete yyvsp[-5].vec; ;
    break;}
case 46:
#line 199 "parser.y"
{ world.push_front (new Sphere (*yyvsp[-3].vec, yyvsp[-1].dbl)); delete yyvsp[-3].vec;     ;
    break;}
case 47:
#line 201 "parser.y"
{ world.push_front (new Sphere (*yyvsp[-5].vec, yyvsp[-3].dbl, yyvsp[-1].dbl)); delete yyvsp[-5].vec; ;
    break;}
case 48:
#line 202 "parser.y"
{ world.push_front (new HeightField (yyvsp[0].str)); ;
    break;}
case 52:
#line 210 "parser.y"
{ static_cast<HeightField*> (world.front())->translate (*yyvsp[0].vec); delete yyvsp[0].vec; ;
    break;}
case 53:
#line 212 "parser.y"
{ static_cast<HeightField*> (world.front())->scale (*yyvsp[0].vec); delete yyvsp[0].vec; ;
    break;}
case 54:
#line 216 "parser.y"
{ yyval.vec = new Vector (yyvsp[-5].dbl, yyvsp[-3].dbl, yyvsp[-1].dbl); ;
    break;}
case 55:
#line 217 "parser.y"
{ yyval.vec = new Vector (X);                                  ;
    break;}
case 56:
#line 218 "parser.y"
{ yyval.vec = new Vector (Y);                                  ;
    break;}
case 57:
#line 219 "parser.y"
{ yyval.vec = new Vector (Z);                                  ;
    break;}
case 58:
#line 220 "parser.y"
{ yyval.vec = new Vector ((*yyvsp[-2].vec) + (*yyvsp[0].vec)); delete yyvsp[-2].vec; delete yyvsp[0].vec;;
    break;}
case 59:
#line 221 "parser.y"
{ yyval.vec = new Vector ((*yyvsp[-2].vec) - (*yyvsp[0].vec)); delete yyvsp[-2].vec; delete yyvsp[0].vec;;
    break;}
case 60:
#line 222 "parser.y"
{ yyval.vec = new Vector (yyvsp[-2].dbl * (*yyvsp[0].vec)); delete yyvsp[0].vec;              ;
    break;}
case 61:
#line 223 "parser.y"
{ yyval.vec = new Vector (yyvsp[0].dbl * (*yyvsp[-2].vec)); delete yyvsp[-2].vec;              ;
    break;}
case 62:
#line 224 "parser.y"
{ yyval.vec = new Vector ((1/yyvsp[0].dbl) * (*yyvsp[-2].vec)); delete yyvsp[-2].vec;          ;
    break;}
case 63:
#line 225 "parser.y"
{ yyval.vec = yyvsp[-1].vec;                                              ;
    break;}
case 64:
#line 226 "parser.y"
{ yyval.vec = new Vector (-(*yyvsp[0].vec)); delete yyvsp[0].vec;                  ;
    break;}
case 65:
#line 229 "parser.y"
{ yyval.dbl = yyvsp[0].dbl;      ;
    break;}
case 66:
#line 230 "parser.y"
{ yyval.dbl = yyvsp[0].dbl;      ;
    break;}
case 67:
#line 231 "parser.y"
{ yyval.dbl = -yyvsp[0].dbl;     ;
    break;}
case 68:
#line 232 "parser.y"
{ yyval.dbl = yyvsp[-2].dbl + yyvsp[0].dbl; ;
    break;}
case 69:
#line 233 "parser.y"
{ yyval.dbl = yyvsp[-2].dbl - yyvsp[0].dbl; ;
    break;}
case 70:
#line 234 "parser.y"
{ yyval.dbl = yyvsp[-2].dbl * yyvsp[0].dbl; ;
    break;}
case 71:
#line 235 "parser.y"
{ yyval.dbl = yyvsp[-2].dbl / yyvsp[0].dbl; ;
    break;}
case 72:
#line 236 "parser.y"
{ yyval.dbl = yyvsp[-1].dbl;      ;
    break;}
case 73:
#line 239 "parser.y"
{ yyval.boo = true;      ;
    break;}
case 74:
#line 240 "parser.y"
{ yyval.boo = false;     ;
    break;}
case 75:
#line 241 "parser.y"
{ yyval.boo = (yyvsp[0].dbl == 0); ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 244 "parser.y"

